import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { Card, CardParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询会员卡
 */
export async function pageCard(params: CardParam) {
  const res = await request.get<ApiResult<PageResult<Card>>>(
    MODULES_API_URL + '/booking/card/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询会员卡列表
 */
export async function listCard(params?: CardParam) {
  const res = await request.get<ApiResult<Card[]>>(
    MODULES_API_URL + '/booking/card',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加会员卡
 */
export async function addCard(data: Card) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/card',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改会员卡
 */
export async function updateCard(data: Card) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/card',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除会员卡
 */
export async function removeCard(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/card/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除会员卡
 */
export async function removeBatchCard(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/card/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询会员卡
 */
export async function getCard(id: number) {
  const res = await request.get<ApiResult<Card>>(
    MODULES_API_URL + '/booking/card/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
